--AH:ScriptId=85abe265-dec1-4529-995b-6f0653465fed;2786
CREATE TABLE [NpmConnectors]
(
	[NpmConnector_Id] INT IDENTITY(1, 1) NOT NULL,
	[Registry_Url] NVARCHAR(1000) NOT NULL,
	[Updated_Date] DATETIME,

	CONSTRAINT [PK__NpmConnectors]
		PRIMARY KEY ([NpmConnector_Id]),

	CONSTRAINT [CK__NpmConnectors__Registry_Url]
		CHECK ([Registry_Url] LIKE 'http://%' OR [Registry_Url] LIKE 'https://%')
)

CREATE TABLE [NpmConnectorPackages]
(
	[NpmConnector_Id] INT NOT NULL,
	[Package_Name] NVARCHAR(200) NOT NULL,
	[Package_Version] VARCHAR(200) NOT NULL,
	[Modified_Date] DATETIME NOT NULL,
	[PackageJson_Bytes] VARBINARY(MAX) NOT NULL,

	CONSTRAINT [PK__NpmConnectorPackages]
		PRIMARY KEY ([NpmConnector_Id], [Package_Name]),

	CONSTRAINT [FK__NpmConnectorPackages__NpmConnectors]
		FOREIGN KEY ([NpmConnector_Id])
		REFERENCES [NpmConnectors] ([NpmConnector_Id]),

	CONSTRAINT [CK__NpmConnectorPackages__Package_Name]
		CHECK ([Package_Name] <> '' AND [Package_Name] NOT LIKE '-%'),

	CONSTRAINT [CK__NpmConnectorPackages__Package_Version]
		CHECK ([Package_Version] <> '')
)

CREATE TABLE [NpmFeedConnectors]
(
	[Feed_Id] INT NOT NULL,
	[NpmConnector_Id] INT NOT NULL,
	[Filter_Csv] NVARCHAR(1000) NULL,

	CONSTRAINT [PK__NpmFeedConnectors]
		PRIMARY KEY ([Feed_Id], [NpmConnector_Id]),

	CONSTRAINT [FK__NpmFeedConnectors__Feeds]
		FOREIGN KEY ([Feed_Id])
		REFERENCES [Feeds] ([Feed_Id]),

	CONSTRAINT [FK__NpmFeedConnectors__NpmConnectors]
		FOREIGN KEY ([NpmConnector_Id])
		REFERENCES [NpmConnectors] ([NpmConnector_Id])
)