EXEC [__AddStoredProcInfo]
    /* StoredProc_Name         */ 'DockerImages_GetImage',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataRow',
    /* DataTableNames_Csv      */ 'DockerImages_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the Docker image with the specified tag or digest.'
GO

IF OBJECT_ID('[DockerImages_GetImage]') IS NOT NULL DROP PROCEDURE [DockerImages_GetImage]
GO

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE PROCEDURE [DockerImages_GetImage]
(
	@Feed_Id INT,
	@Repository_Name VARCHAR(255),
	@TagOrDigest_Name VARCHAR(128)
)
AS
BEGIN

SET NOCOUNT ON

	SELECT *
	  FROM [DockerImages_Extended]
	 WHERE [Feed_Id] = @Feed_Id
	   AND [Repository_Name] = @Repository_Name
	   AND [Image_Digest] = @TagOrDigest_Name

	UNION
	
	SELECT DI.*
	  FROM [DockerRepositoryTags] DRT
	       INNER JOIN [DockerImages_Extended] DI
		           ON DI.[DockerImage_Id] = DRT.[DockerImage_Id]
	 WHERE DI.[Feed_Id] = @Feed_Id
	   AND DI.[Repository_Name] = @Repository_Name
	   AND DRT.[Tag_Name] = @TagOrDigest_Name

END
GO

GRANT EXECUTE ON [DockerImages_GetImage] TO [ProGetUser_Role]
GO